
/*                              EJEMPLO1.C
  Ŀ
   - Este es un programa que visualiza imgenes PCX de 256 colores        
     de 320x200, 640x480, 800x600 y 1024x768.                             
                                                                          
     Los bucles de descompresin estn hechos en C                        
                                                                          
  
    ]Bizarre inc.[
	   
*/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "svgalibs\vesalib.h"
#include "svgalibs\ints.h"
#include "svgalibs\palette.h"

#ifndef STANDARDTYPES
    #define STANDARDTYPES
      typedef  unsigned char *  address;
      typedef  unsigned char    byte;
      typedef  unsigned short   word;
      typedef  unsigned long    dword;
    #endif

void descomprime (FILE *);              /* Rutina de descompresin          */
void SetPalette  ( char far * );        /* Coloca la paleta correspondiente */

typedef struct {
 byte      Manufacturer    ; /*  Constant Flag, 10 = ZSoft .pcx              */
 byte      Version         ; /*  Version information                         */
			     /*  0 = Version 2.5 of PC Paintbrush            */
			     /*  2 = Version 2.8 w/palette information       */
			     /*  3 = Version 2.8 w/o palette information     */
			     /*  4 = PC Paintbrush for Windows(Plus for      */
			     /*     Windows uses Ver 5)                      */
			     /*  5 = Version 3.0 and > of PC Paintbrush      */
			     /*     and PC Paintbrush +, includes            */
			     /*     Publisher's Paintbrush . Includes        */
			     /*     24-bit .PCX files                        */
 byte      Encoding        ; /*  1 = .PCX run length encoding                */
 byte      BitsPerPixel    ; /*  Number of bits to represent a pixel         */
			     /*     (per Plane) - 1, 2, 4, or 8              */
 word      Window [4]      ; /*  Image Dimensions: Xmin,Ymin,Xmax,Ymax       */
 word      HDpi            ; /*  Horizontal Resolution of image in DPI*      */
 word      VDpi            ; /*  Vertical Resolution of image in DPI*        */
 byte      Colormap [48]   ; /*  Color palette setting, see text             */
 byte      Reserved        ; /*  Should be set to 0.                         */
 byte      NPlanes         ; /*  Number of color planes                      */
 word      BytesPerLine    ; /*  Number of bytes to allocate for a scanline  */
			     /*     plane.  MUST be an EVEN number.  Do NOT  */
			     /*     calculate from Xmax-Xmin.                */
 word      PaletteInfo     ; /*  How to interpret palette- 1 = Color/BW,     */
			     /*     2 = Grayscale (ignored in PB IV/ IV +)   */
 word      HscreenSize     ; /*  Horizontal screen size in pixels. New field */
			     /*     found only in PB IV/IV Plus              */
 word      VscreenSize     ; /*  Vertical screen size in pixels. New field   */
			     /*     found only in PB IV/IV Plus              */
 byte      Filler [54]     ; /*  Blank to fill out 128 byte header.  Set all */
			     /*     bytes to 0                               */
} PCX_HEADER;

/*
  - En la resolucin de 320x200 (0x13) le he aadido al byte alto
    el valor 0xFF00 para distinguirlo de los modos SVGA, puesto que
    no se inician de la misma forma. As, al detectar en el byte alto
    el valor 0xFF se inicia el modo VGA con el byte bajo 0x13
*/
int modos [4] = {
       /*  320x200    640x480     800x600   1024x768   */
	   0xFF13  ,  0x0101  ,   0x0103  ,  0x0105
		    };

char indice;           /* indice para el array de modos        */
int Xtotal, Ytotal;    /* Xmax-Xmin,  Ymax-Ymin                */
PCX_HEADER cabecera;   /* Aqui se almacena la cabecera del PCX */
byte paleta [768];     /* Paleta de la imagen */
int x, y;
int ancho;             /* Se almacena el ancho de la resolucin
			  de la pantalla                        */

void main (int argc, char * argv[])
{
  FILE * fich;

  if ( argc < 2 )
  {
     printf ("\r\n");
     printf ("Falta el nombre del fichero PCX \r\n\r\n");
     printf ("EJEMPLO1 <nombre_fichero.pcx>");
     printf ("\r\n");
     exit(1);
  }

  fich = fopen (argv[1], "rb" );               /* Abrir fichero */
  if (fich == NULL)
  {
    printf ("\r\n");
    printf ("Error abriendo el fichero ");
    printf ("\r\n");
    exit (1);
  }
  
  if ( GetSVGAInfo() )
  {
    printf ("\r\n");
    printf ("No se pudo encontrar la VESA, saliendo ... ");
    printf ("\r\n");
    exit (1);
  } else
  {
   printf("Driver VESA SVGA instalado.\r\n");
   printf("\r\nFabricante (OEM):           " );
   while( *VesaDriver.oem != '\0' ) 
     { 
      printf("%c", *VesaDriver.oem );
      VesaDriver.oem++;
     }
   printf("\r\nVersin:                    %u.%u", (VesaDriver.version>>8),
						   (VesaDriver.version & 0xFF) );
   printf("\r\nBloques de 64Kb de VRAM:    %u", VesaDriver.videomem );
   printf("\r\nTamao total de VRAM:       %u", VesaDriver.videomem*64 );
   printf("\r\n");
   getch();
  }

  fread (&cabecera, sizeof (cabecera), 1, fich);  /* Almacenar cabecera */

  clrscr();
  printf ("                 EJEMPLO1.C \r\n");
  printf ("                 \n\r");
  printf (" - Visualiza ficheros PCX de 256 colores y con \r\n");
  printf (" resoluciones de 320x200, 640x480, 800x600 y   \r\n");
  printf (" 1024x768. Utiliza modos VESA standards no     \r\n");
  printf (" lineales por lo que no hace falta una versin \r\n");
  printf (" avanzada de la VESA.");

  getch();
  clrscr();

  printf (" Cabecera del fichero PCX  \r\n");
  printf (" \r\n");

  printf ("Manufacturer  : %u\r\n",cabecera.Manufacturer );
  printf ("Version       : %u\r\n",cabecera.Version  );
  printf ("Encoding      : %u\r\n",cabecera.Encoding  );
  printf ("BitsPerPixel  : %u\r\n",cabecera.BitsPerPixel   );
  printf ("Window        : \r\n" );
  printf ("       Xmin    : %u          Ymin : %u\r\n",cabecera.Window[0], cabecera.Window[1] );
  printf ("       Xmax    : %u          Ymax : %u\r\n",cabecera.Window[2], cabecera.Window[3] );
  printf ("HDpi          : %u\r\n", cabecera.HDpi );
  printf ("VDpi          : %u\r\n", cabecera.VDpi );
  printf ("Colormap      : %s\r\n", cabecera.Colormap  );
  printf ("Reserved      : %u\r\n",cabecera.Reserved  );
  printf ("NPlanes       : %u\r\n",cabecera.NPlanes  );
  printf ("BytesPerLine  : %u\r\n",cabecera.BytesPerLine  );
  printf ("PaletteInfo   : %u\r\n",cabecera.PaletteInfo    );
  printf ("HscreenSize   : %u\r\n",cabecera.HscreenSize     );
  printf ("VscreenSize   : %u\r\n",cabecera.VscreenSize  );
  printf ("Filler        : %s\r\n",cabecera.Filler  );

  Xtotal = cabecera.Window[2] - cabecera.Window[0];
  Ytotal = cabecera.Window[3] - cabecera.Window[1];

       if ( ( Xtotal <= 320 ) && ( Ytotal <= 200 ) ) {indice = 0;ancho = 320;}
  else if ( ( Xtotal <= 640 ) && ( Ytotal <= 480 ) ) {indice = 1;ancho = 640;}
  else if ( ( Xtotal <= 800 ) && ( Ytotal <= 600 ) ) {indice = 2;ancho = 800;}
  else if ( ( Xtotal <=1024 ) && ( Ytotal <= 768 ) ) {indice = 3;ancho =1024;}
  else  {
	   printf("La imagen es demasiado grande !");
	   exit(1);
	}


       if ( cabecera.BitsPerPixel == 8 )        /* Comprobar n de colores */
	{
	  fseek (fich, -768, SEEK_END);
	  fread (paleta , 768, 1, fich);        /* Leer la paleta */
	  for (x=0;x<768;x++) paleta[x] /= 4;   /* y dividir cada valor /4 */
	}
	else
	{
	   printf("La imagen no es de 256 colores!");
	   exit(1);
	}

  getch();

  if ( (modos[indice] & 0xFF00) == 0xFF00)  /*modos VGA*/
  {
   _AX = modos[indice] & 0x00FF;
   asm int 0x10;
  }
  else
     SetSVGAVideoMode(modos[indice], Xtotal, Ytotal );

  SetPalette (paleta);
  descomprime (fich);

  fclose (fich);

  getch();
  asm {
    mov ax, 0x03
    int 0x10
  }
}


void descomprime (FILE * fichero)
{
  int a, x, y;
  dword pos;
  byte dato1, dato2;

  pos = 0;
  fseek (fichero, 128, SEEK_SET);           /* Saltamos la cabecera */

for (a=0;a<Ytotal;a++)                      /* Bucle que controla en alto */
{                                           /* del dibujo                 */
  for (x=0;x<cabecera.BytesPerLine;)        /* Bucle para el ancho de la  */
  {                                         /* imagen                     */
     fread (&dato1, sizeof (dato1), 1, fichero);     /* Leemos el valor   */
     if (dato1 > 192  )                              /* Si los dos bits altos */
     {                                               /* estn activados ...   */
	fread (&dato2, sizeof (dato2), 1, fichero);  /* Leer segundo valor    */
	for (y=0;y<(dato1 - 192);y++,pos++, x++)     /* Repetir (dato1 sin los bits superiores) veces */
	     SVGAPutPixelAbs ( pos, dato2 );         /* escribir dato2 en pantalla */
     }
     else                                            /* Si dos bits altos desactivados, */
     {                                               /* escribe en pantalla dato1 */
	 SVGAPutPixelAbs ( pos, dato1);
	 pos++; x++;
     }
  }
  pos += ancho-cabecera.BytesPerLine ;               /* Si la imagen es ms estrecha que el
							ancho de la resolucin, aadir el
							resto que falta a cada linea */
}
}

