/*
  - Este ejemplo es igual al anterior, pero el bucle de descompresin
    est en ensamblador y slo permite visualizar imgenes de 320x200.
    Sin embargo, el mtodo de descompresin de todas las imgenes es el
    mismo, como se explica en el artculo.

    ]Bizarre inc.[
	   

*/



#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "svgalibs\ints.h"
#include "svgalibs\palette.h"

#ifndef STANDARDTYPES
    #define STANDARDTYPES
      typedef  unsigned char *  address;
      typedef  unsigned char    byte;
      typedef  unsigned short   word;
      typedef  unsigned long    dword;
 #endif

void descomprime (FILE *);

typedef struct {

 byte      Manufacturer    ; /*  Constant Flag, 10 = ZSoft .pcx              */
 byte      Version         ; /*  Version information                         */
			     /*  0 = Version 2.5 of PC Paintbrush            */
			     /*  2 = Version 2.8 w/palette information       */
			     /*  3 = Version 2.8 w/o palette information     */
			     /*  4 = PC Paintbrush for Windows(Plus for      */
			     /*     Windows uses Ver 5)                      */
			     /*  5 = Version 3.0 and > of PC Paintbrush      */
			     /*     and PC Paintbrush +, includes            */
			     /*     Publisher's Paintbrush . Includes        */
			     /*     24-bit .PCX files                        */
 byte      Encoding        ; /*  1 = .PCX run length encoding                */
 byte      BitsPerPixel    ; /*  Number of bits to represent a pixel         */
			     /*     (per Plane) - 1, 2, 4, or 8              */
 word      Window [4]      ; /*  Image Dimensions: Xmin,Ymin,Xmax,Ymax       */
 word      HDpi            ; /*  Horizontal Resolution of image in DPI*      */
 word      VDpi            ; /*  Vertical Resolution of image in DPI*        */
 byte      Colormap [48]   ; /*  Color palette setting, see text             */
 byte      Reserved        ; /*  Should be set to 0.                         */
 byte      NPlanes         ; /*  Number of color planes                      */
 word      BytesPerLine    ; /*  Number of bytes to allocate for a scanline  */
			     /*     plane.  MUST be an EVEN number.  Do NOT  */
			     /*     calculate from Xmax-Xmin.                */
 word      PaletteInfo     ; /*  How to interpret palette- 1 = Color/BW,     */
			     /*     2 = Grayscale (ignored in PB IV/ IV +)   */
 word      HscreenSize     ; /*  Horizontal screen size in pixels. New field */
			     /*     found only in PB IV/IV Plus              */
 word      VscreenSize     ; /*  Vertical screen size in pixels. New field   */
			     /*     found only in PB IV/IV Plus              */
 byte      Filler [54]     ; /*  Blank to fill out 128 byte header.  Set all */
			     /*     bytes to 0                               */
} PCX_HEADER;

int Xtotal, Ytotal;    /* Xmax-Xmin,  Ymax-Ymin                */
PCX_HEADER cabecera;   /* Aqui se almacena la cabecera del PCX */
byte paleta [768];     /* Paleta de la imagen */
int x, y;
int ancho;

void main (int argc, char * argv[])
{
  FILE * fich;

  if ( argc < 2 )
  {
     printf ("\r\n");
     printf ("Falta el nombre del fichero PCX \r\n\r\n");
     printf ("EJEMPLO2 <nombre_fichero.pcx>");
     printf ("\r\n");
     exit(1);
  }

  fich = fopen (argv[1], "rb" );
  if (fich == NULL)
  {
    printf ("\r\n");
    printf ("Error abriendo el fichero ");
    printf ("\r\n");
    exit (1);
  }
  
  fread (&cabecera, sizeof (cabecera), 1, fich);

  clrscr();
  printf (" - Este programa visualiza imgenes de 320x200 y 256\r\n");
  printf (" colores, pero la descompresin est en ensamlador. \r\n");

  getch();
  clrscr();

  printf (" Cabecera del fichero PCX  \r\n");
  printf (" \r\n");

  printf ("Manufacturer  : %u\r\n",cabecera.Manufacturer );
  printf ("Version       : %u\r\n",cabecera.Version  );
  printf ("Encoding      : %u\r\n",cabecera.Encoding  );
  printf ("BitsPerPixel  : %u\r\n",cabecera.BitsPerPixel   );
  printf ("Window        : \r\n" );
  printf ("       Xmin    : %u          Ymin : %u\r\n",cabecera.Window[0], cabecera.Window[1] );
  printf ("       Xmax    : %u          Ymax : %u\r\n",cabecera.Window[2], cabecera.Window[3] );
  printf ("HDpi          : %u\r\n", cabecera.HDpi );
  printf ("VDpi          : %u\r\n", cabecera.VDpi );
  printf ("Colormap      : %s\r\n", cabecera.Colormap  );
  printf ("Reserved      : %u\r\n",cabecera.Reserved  );
  printf ("NPlanes       : %u\r\n",cabecera.NPlanes  );
  printf ("BytesPerLine  : %u\r\n",cabecera.BytesPerLine  );
  printf ("PaletteInfo   : %u\r\n",cabecera.PaletteInfo    );
  printf ("HscreenSize   : %u\r\n",cabecera.HscreenSize     );
  printf ("VscreenSize   : %u\r\n",cabecera.VscreenSize  );
  printf ("Filler        : %s\r\n",cabecera.Filler  );

  Xtotal = cabecera.Window[2] - cabecera.Window[0];
  Ytotal = cabecera.Window[3] - cabecera.Window[1];

       if ( ( Xtotal <= 320 ) && ( Ytotal <= 200 ) ) ancho = 320;
  else  {
	   printf("La imagen es demasiado grande !");
	   exit(1);
	}

  getch();

       if ( cabecera.BitsPerPixel == 8 )
	{
	  fseek (fich, -768, SEEK_END);
	  fread (paleta , 768, 1, fich);
	  for (x=0;x<768;x++) paleta[x] /= 4;
	}
	else
	{
	   printf("La imagen es de 16 colores!");
	   exit(1);
	}

   asm mov ax, 0x13;
   asm int 0x10;

  SetPalette (paleta);
  descomprime (fich);

  fclose (fich);

  getch();
  asm {
    mov ax, 0x03
    int 0x10
  }
}


void descomprime (FILE * fichero)
{
  dword pos = 0, pf = 0;
  byte dato1, dato2;
  byte imagen [1000];            /* En este array se almacenan valores */
				/* comprimidos temporalmente para     */
				/* descomprimirlos linea a linea      */

  fseek (fichero, 128, SEEK_SET);
  fread (imagen, sizeof (imagen), 1, fichero);
  pf = 128;

  asm {
       mov ax, 0xA000
       mov es, ax
       xor di, di                     /* Se inicia el segmento de pantalla */

       mov si, [Ytotal]               /* Bucle de la altura */
       }
    alto:
    asm {
	 mov dx, word ptr cabecera.BytesPerLine  /* Bucle para el ancho */
	 }
    linea:
    _AX = imagen[pos]; pos++;pf++;      /* Leer valor del array comprimido */
  asm {
       cmp al, 192                      /* Compararlo con 192 */
       ja  compr                        /* Si es mayor, saltar a compr */
       stosb                            /* Si no, ponerlo en pantalla  */
       dec dx                           /* Decrementa el bucle del ancho */
       jmp fin                          /* Salta a "fin del pixel" */
       }
    compr:                              /* Si comprimido:  */
  asm {
       xor cx, cx
       mov cl, al                       /* Almacena el valor en cl ... */
       sub cl, 192                      /* pero desactivando los dos bits */
					/* de mas peso. Es el bucle del  */
       }                                /* pixel comprimido */
       _AX = imagen[pos]; pos++;pf++;   /* Lee segundo valor             */
  asm  {
	sub dx, cx                      /* Decrementa CX veces del bucle ancho */
	rep stosb                       /* Pon en pantalla CX veces el   */
					/* segundo valor */
       }
  fin:                            /* Fin de la descompresin de un pixel */
  asm {
       cmp dx, 0                  /* Fin de linea? */
       jnz linea                  /* Si no, repetir proceso */
       add di, ancho              /* Si fin de linea, ... */
       sub di, word ptr cabecera.BytesPerLine  /* aadir el trozo que falta entre la */
       pusha                          /* imagen y la pantalla ( si la imagen es ms estrecha) */
       }
	 fseek (fichero, pf, SEEK_SET);    /* Posicionar el fichero para leer ... */
	 fread (imagen, sizeof (imagen), 1, fichero);  /* ms valores provisionales para la siguiente linea*/
	 pos = 0;                          /* indice del array provisional a cero */
    asm{
       popa
       dec si                              /* Decrementa bucle Y */
       jz  final:                          /* Si es cero, finalizar */
       jmp alto                            /* Si no, repite el proceso */
      }
    final:
}
