/*      

   - Visualiza un fichero con formato crudo o RAW, con el siguiente
     formato:
       - byte  -  Bits por pixel
       - word  - ancho
       - word - alto
       - paleta de 768 bytes
       - Cuerpo de la imagen

    ]Bizarre inc.[
	   
*/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "svgalibs\vesalib.h"
#include "svgalibs\ints.h"
#include "svgalibs\palette.h"
 
#ifndef STANDARDTYPES
    #define STANDARDTYPES
      typedef  unsigned char *  address;
      typedef  unsigned char    byte;
      typedef  unsigned short   word;
      typedef  unsigned long    dword;
 #endif

typedef struct {
   byte Bits_por_pixel;
   word ancho;
   word alto;
} RAW_HDR;

void descomprime (FILE *);

int modos [4] = {         /*    modos[modos]        */
       /*  320x200    640x480     800x600   1024x768   */
	   0xFF13  ,  0x0101  ,   0x0103  ,  0x0105
		    };

char indice ; /* indices para el array de modos */
byte paleta [768];
RAW_HDR cabecera;
int x;
int ancho_pant;

void main (int argc, char * argv[])
{
  FILE * fich;

  if (argc < 2)
  {
    printf ("\r\n");
    printf ("Falta el nombre del fichero RAW! \r\n\r\n");
    printf ("EJEMPLO3 <nombre_fichero.RAW>");
    printf ("\r\n");
    exit(1);
  }

  fich = fopen (argv[1], "rb" );

  if (fich == NULL)
  {
    printf ("\r\n");
    printf ("Error abriendo el fichero ");
    printf ("\r\n");
    exit (1);
  }
  
  if ( GetSVGAInfo() )
  {
    printf ("\r\n");
    printf ("No se pudo encontrar la VESA, saliendo ... ");
    printf ("\r\n");
    exit (1);
  } else
  {
   printf("Driver VESA SVGA instalado.\r\n");
   printf("\r\nFabricante (OEM):           " );
   while( *VesaDriver.oem != '\0' ) 
     { 
      printf("%c", *VesaDriver.oem );
      VesaDriver.oem++;
     }
   printf("\r\nVersin:                    %u.%u", (VesaDriver.version>>8),
						   (VesaDriver.version & 0xFF) );
   printf("\r\nBloques de 64Kb de VRAM:    %u", VesaDriver.videomem );
   printf("\r\nTamao total de VRAM:       %u", VesaDriver.videomem*64 );
   printf("\r\n");
   getch();
  }

  fread (&cabecera, sizeof (cabecera), 1, fich);

  clrscr();

  printf ("    - Visualiza un fichero con formato crudo o RAW, con el siguiente");
  printf ("    formato:");
  printf ("      - byte  -  Bits por pixel\r\n");
  printf ("      - word  - ancho\r\n");
  printf ("      - word - alto\r\n");
  printf ("      - paleta de 768 bytes\r\n");
  printf ("      - Cuerpo de la imagen\r\n");

  getch();
  clrscr();

  printf (" Cabecera del fichero RAW  \r\n");
  printf (" \r\n");

  printf ("Bits_por_pixel: %u\r\n",cabecera.Bits_por_pixel );
  printf ("ancho         : %u\r\n",cabecera.ancho  );
  printf ("alto          : %u\r\n",cabecera.alto  );

       if ( ( cabecera.ancho <= 320 ) && ( cabecera.alto <= 200 ) )
	  {indice = 0;
	  ancho_pant = 320;}
  else if ( ( cabecera.ancho <= 640 ) && ( cabecera.alto <= 480 ) )
	  {indice = 1;
	  ancho_pant = 640;}
  else if ( ( cabecera.ancho <= 800 ) && ( cabecera.alto <= 600 ) )
	  {indice = 2;
	  ancho_pant = 800;}
  else if ( ( cabecera.ancho <=1024 ) && ( cabecera.alto <= 768 ) )
	  {indice = 3;
	  ancho_pant =1024;}
  else indice = -1;   /* Imagen demasiado grande! */

  if ( cabecera.Bits_por_pixel == 8 )
	{
	  fseek (fich, 5, SEEK_SET);          /* Salta cabecera */
	  fread (paleta , 768, 1, fich);
	}
  else indice = -1;   /* Slo admite 256 colores! */

  getch();

  if ( indice == -1 ) exit(1);

  if ( (modos[indice] & 0xFF00) == 0xFF00)  /*modos VGA*/
  {
   _AX = modos[indice] & 0x00FF;
   asm int 0x10;
  } 
  else 
	SetSVGAVideoMode(modos[indice], cabecera.ancho, cabecera.alto );

  SetPalette (paleta );
  descomprime (fich);

  fclose (fich);

  getch();
  asm {
    mov ax, 0x03
    int 0x10
  }

}


void descomprime (FILE * fichero)
{
  int a, x, y;
  dword pos;
  char valor;
  word ancho=0;

  pos = 0;
  fseek (fichero, 768, SEEK_SET);

  fread (&valor, 1, 1, fichero);
  while (!feof(fichero))
  {
    fread (&valor, 1, 1, fichero);
    if (ancho == cabecera.ancho)
       {
	 pos += (ancho_pant - cabecera.ancho)-1;
	 ancho = 0;
       } else ancho++;
    SVGAPutPixelAbs (pos, valor);
    pos++;
  };
}

