#include "RAW.H"
#include "PCX.H"

RAW_HDR cabecera;
dword offset;

byte GetPixel ( void );

void main (int argc, char * argv[])
{
   FILE * fich;
   int x;
   dword banco, offs, contador, bytecounter;
   byte paleta[768];
   byte b1, b2, car;
   word ancho;
   word rellenacab;

   if (argc == 1)
   {
     printf ("\r\n");
     printf ("EJEMPLO4.EXE\n\r");
     printf ("Este programa abre un fichero RAW para convertirlo en un PCX.");
     printf ("\r\nEJEMPLO4 <fichero_RAW> <fichero_PCX>");
     printf ("\r\n");
     exit(1);
   }

   if ( argc < 3 )
   {
     printf ("\r\n");
     printf ("Faltan parmetros\r\n\r\n");
     printf ("EJEMPLO4 <fichero_RAW> <fichero_PCX>");
     printf ("\r\n");
     exit(1);
   }

      fich = fopen (argv[2], "wb");
   if (fich == NULL)
   {
     printf ("Error abriendo fichero destino\r\n");
     printf ("EJEMPLO4 <fichero_RAW> <fichero_PCX>");
     exit(1);
   }
  
  if ( GetSVGAInfo() )
  {
    printf ("\r\n");
    printf ("No se pudo encontrar la VESA, saliendo ... ");
    printf ("\r\n");
    exit (1);
  } else
  {
   printf("Driver VESA SVGA instalado.\r\n");
   printf("\r\nFabricante (OEM):           " );
   while( *VesaDriver.oem != '\0' ) 
     { 
      printf("%c", *VesaDriver.oem );
      VesaDriver.oem++;
     }
   printf("\r\nVersin:                    %u.%u", (VesaDriver.version>>8),
						   (VesaDriver.version & 0xFF) );
   printf("\r\nBloques de 64Kb de VRAM:    %u", VesaDriver.videomem );
   printf("\r\nTamao total de VRAM:       %u", VesaDriver.videomem*64 );
   printf("\r\n");
   getch();
  }

   cabecera = RAW (argv[1]);

   fputc (10, fich);         /* Valor cte */
   fputc (5, fich);          /* Version */
   fputc (1, fich);          /* Encoding */
   fputc (cabecera.Bits_por_pixel, fich); /* BitsPerPixel - en 256 colores = 8   */
   rellenacab = 0;
   fwrite (&rellenacab, 2, 1, fich);   /* Xmin */
   fwrite (&rellenacab, 2, 1, fich);   /* Ymin */
   rellenacab = cabecera.ancho;
   fwrite (&rellenacab, 2, 1, fich);   /* Xmax */
   rellenacab = cabecera.alto;
   fwrite (&rellenacab, 2, 1, fich);   /* Ymax */
   rellenacab = 0;
   fwrite (&rellenacab, 2, 1, fich);   /* Hdpi */
   fwrite (&rellenacab, 2, 1, fich);   /* Vdpi */
   for (rellenacab=0;rellenacab<48;rellenacab++)
    fputc (0, fich);                   /* Paleta de 16 colores */
   fputc (0, fich);          /* Reservado  */
   fputc (1, fich);          /* N planos  */
   rellenacab = cabecera.ancho;
   fwrite (&rellenacab, 2, 1, fich);   /* Bytes por linea */
   rellenacab = 1;
   fwrite (&rellenacab, 2, 1, fich);   /* Palette info */
   rellenacab = cabecera.ancho;
   fwrite (&rellenacab, 2, 1, fich);   /* Hscreensize */
   rellenacab = cabecera.alto;
   fwrite (&rellenacab, 2, 1, fich);   /* Vscreensize */
   for (rellenacab=0;rellenacab<52;rellenacab++)
    fputc (0, fich);                   /* Paleta de 16 colores */


/******    Inicio de la compresin de la imagen          *****/

   contador = (cabecera.ancho+1);
   contador *= (cabecera.alto+1);
   bytecounter = 1;
   offset = 0; ancho = 0;
   b1 = GetPixel ();
   offset++;
do {
   b2 = GetPixel ();
   offset++; ancho++;

     while ((b2 == b1) && (bytecounter < 63) && (ancho < cabecera.ancho))
	   {
	    bytecounter++;
	    b2 = GetPixel ();
	    offset++;ancho++;
	   }
     if (ancho >= cabecera.ancho)
     {
       offset += ancho_pant-ancho;
       ancho = 0;
     }

     if (bytecounter != 1)
	{
	  car = 192+bytecounter;
	  fwrite (&car, 1, 1, fich);         // Escribe como comprimido
	  fwrite (&b1, 1, 1, fich);          // Escribe color
	}

     if (bytecounter == 1)
	{
	  if (b1 < 192) fputc (b1, fich);
	  else
	      {
	      car = 193;        // 192 + 1 }
	      fwrite(&car, 1, 1, fich);
	      fwrite(&b1, 1, 1, fich);
	      }
	}

bytecounter = 1;
b1 = b2;
} while (offset <= contador);   /* Ancho * alto */

GetPalette (paleta);
for (x=0;x<768;x++) paleta[x] *=4;
fwrite (paleta, 768, 1, fich);
fclose (fich);
getch();

PCX (argv[2]);

getch();

asm {
    mov ax, 0x3;
    int 0x10;
    }

}

byte GetPixel ( void )
{
word banco, offs;

      banco = offset >> 16;
      SVGASwitchBank( banco );
      offs = offset - (banco << 16);
      return (peekb (0xA000, offs));
}
