/*
  - Utilidad para convertir los ficheros PCX en crudos.
*/

#include "RAW.H"
#include "PCX.H"

PCX_HEADER cab;

byte GetPixel ( dword );

void main (int argc, char * argv[])
{
   FILE * fich;
   int x;
   word an, al, banco, offs;
   dword absoluto, ancho_r, alto;
   byte paleta[768];
   byte b1;

   if (argc == 0)
   {
     printf ("EJEMPLO5.EXE\n\r");
     printf ("Este programa abre un fichero PCX para convertirlo en un RAW.");
     printf ("\r\nEJEMPLO4 <fichero_PCX> <fichero_RAW>");
     exit(1);
   }

   if ( argc < 3 )
   {
     printf ("\r\n");
     printf ("Faltan parmetros\r\n\r\n");
     printf ("EJEMPLO5 <fichero_PCX> <fichero_RAW>");
     printf ("\r\n");
     exit(1);
   }

      fich = fopen (argv[2], "wb");
   if (fich == NULL)
   {
     printf ("\r\n");
     printf ("Error abriendo fichero destino\r\n");
     printf ("EJEMPLO5 <fichero_PCX> <fichero_RAW>");
     printf ("\r\n");
     exit(1);
   }

  if ( GetSVGAInfo() )
  {
    printf ("\r\n");
    printf ("No se pudo encontrar la VESA, saliendo ... ");
    printf ("\r\n");
    exit (1);
  } else
  {
   printf("Driver VESA SVGA instalado.\r\n");
   printf("\r\nFabricante (OEM):           " );
   while( *VesaDriver.oem != '\0' ) 
     { 
      printf("%c", *VesaDriver.oem );
      VesaDriver.oem++;
     }
   printf("\r\nVersin:                    %u.%u", (VesaDriver.version>>8),
						   (VesaDriver.version & 0xFF) );
   printf("\r\nBloques de 64Kb de VRAM:    %u", VesaDriver.videomem );
   printf("\r\nTamao total de VRAM:       %u", VesaDriver.videomem*64 );
   printf("\r\n");
   getch();
  }

   cab = PCX (argv[1]);

   fputc (cab.BitsPerPixel, fich);
   fwrite(&cab.Window[2], 2, 1, fich);
   fwrite(&cab.Window[3], 2, 1, fich);          /* Cabecera */

   GetPalette( paleta );
   fwrite (paleta, 768, 1, fich);

   ancho_r = cab.Window[2];
   alto = cab.Window[3];

   Current_Bank = 1;

   for (al=0;al<alto;al++)
       for (an=0;an<ancho_r;an++)
       {
	  absoluto = ancho-1;
	  absoluto *= al;
	  absoluto += an;
	  b1 = GetPixel( absoluto );
	  fputc (b1, fich);
       }

fclose (fich);

getch();

RAW (argv[2]);

getch();

asm {
    mov ax, 0x3;
    int 0x10;
    }

}

byte GetPixel ( dword offset )
{
word banco, offs;

      banco = offset >> 16;
      SVGASwitchBank( banco );
      offs = offset - (banco << 16);
      return (peekb (0xA000, offs));
}
