/*
  Ŀ
   - Este es un include para utilizar imgenes PCX dentro de los          
     programas. Admite resoluciones desde 320x200 hasta 1024x768 con      
     256 colores.                                                         
                                                                          
  
    ]Bizarre inc.[
	   

*/
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#ifndef STANDARDTYPES
    #define STANDARDTYPES
      typedef  unsigned char *  address;
      typedef  unsigned char    byte;
      typedef  unsigned short   word;
      typedef  unsigned long    dword;
    #endif

typedef struct {
 byte      Manufacturer    ; /*  Constant Flag, 10 = ZSoft .pcx              */
 byte      Version         ; /*  Version information                         */
			     /*  0 = Version 2.5 of PC Paintbrush            */
			     /*  2 = Version 2.8 w/palette information       */
			     /*  3 = Version 2.8 w/o palette information     */
			     /*  4 = PC Paintbrush for Windows(Plus for      */
			     /*     Windows uses Ver 5)                      */
			     /*  5 = Version 3.0 and > of PC Paintbrush      */
			     /*     and PC Paintbrush +, includes            */
			     /*     Publisher's Paintbrush . Includes        */
			     /*     24-bit .PCX files                        */
 byte      Encoding        ; /*  1 = .PCX run length encoding                */
 byte      BitsPerPixel    ; /*  Number of bits to represent a pixel         */
			     /*     (per Plane) - 1, 2, 4, or 8              */
 word      Window [4]      ; /*  Image Dimensions: Xmin,Ymin,Xmax,Ymax       */
 word      HDpi            ; /*  Horizontal Resolution of image in DPI*      */
 word      VDpi            ; /*  Vertical Resolution of image in DPI*        */
 byte      Colormap [48]   ; /*  Color palette setting, see text             */
 byte      Reserved        ; /*  Should be set to 0.                         */
 byte      NPlanes         ; /*  Number of color planes                      */
 word      BytesPerLine    ; /*  Number of bytes to allocate for a scanline  */
			     /*     plane.  MUST be an EVEN number.  Do NOT  */
			     /*     calculate from Xmax-Xmin.                */
 word      PaletteInfo     ; /*  How to interpret palette- 1 = Color/BW,     */
			     /*     2 = Grayscale (ignored in PB IV/ IV +)   */
 word      HscreenSize     ; /*  Horizontal screen size in pixels. New field */
			     /*     found only in PB IV/IV Plus              */
 word      VscreenSize     ; /*  Vertical screen size in pixels. New field   */
			     /*     found only in PB IV/IV Plus              */
 byte      Filler [54]     ; /*  Blank to fill out 128 byte header.  Set all */
			     /*     bytes to 0                               */
} PCX_HEADER;

PCX_HEADER PCX (char * nombre);
void Descomprime_PCX (FILE *);              /* Rutina de descompresin          */

char indice;           /* indice para el array de modos        */
int Xtotal, Ytotal;    /* Xmax-Xmin,  Ymax-Ymin                */
PCX_HEADER cabeceraPCX;   /* Aqui se almacena la cabecera del PCX */
byte paleta [768];     /* Paleta de la imagen */
int x, y;
int ancho;             /* Se almacena el ancho de la resolucin
			  de la pantalla                        */

PCX_HEADER PCX (char * nombre)
{
  FILE * fich;
/*
  - En la resolucin de 320x200 (0x13) le he aadido al byte alto
    el valor 0xFF00 para distinguirlo de los modos SVGA, puesto que
    no se inician de la misma forma. As, al detectar en el byte alto
    el valor 0xFF se inicia el modo VGA con el byte bajo 0x13
*/
int modos [4] = {
       /*  320x200    640x480     800x600   1024x768   */
	   0xFF13  ,  0x0101  ,   0x0103  ,  0x0105
		    };
  fich = fopen (nombre, "rb" );               /* Abrir fichero */
  if (fich == NULL)
  {
    printf ("Error abriendo el fichero ");
    exit (1);
  }
  
  fread (&cabeceraPCX, sizeof (cabeceraPCX), 1, fich);  /* Almacenar cabecera */

  clrscr();

  Xtotal = cabeceraPCX.Window[2] - cabeceraPCX.Window[0];
  Ytotal = cabeceraPCX.Window[3] - cabeceraPCX.Window[1];

       if ( ( Xtotal <= 320 ) && ( Ytotal <= 200 ) ) {indice = 0;ancho = 320;}
  else if ( ( Xtotal <= 640 ) && ( Ytotal <= 480 ) ) {indice = 1;ancho = 640;}
  else if ( ( Xtotal <= 800 ) && ( Ytotal <= 600 ) ) {indice = 2;ancho = 800;}
  else if ( ( Xtotal <=1024 ) && ( Ytotal <= 768 ) ) {indice = 3;ancho =1024;}
  else  {
	   printf("La imagen es demasiado grande !");
	   exit(1);
	}


       if ( cabeceraPCX.BitsPerPixel == 8 )        /* Comprobar n de colores */
	{
	  fseek (fich, -768, SEEK_END);
	  fread (paleta , 768, 1, fich);        /* Leer la paleta */
	  for (x=0;x<768;x++) paleta[x] /= 4;   /* y dividir cada valor /4 */
	}
	else
	{
	   printf("La imagen no es de 256 colores!");
	   exit(1);
	}

  if ( (modos[indice] & 0xFF00) == 0xFF00)  /*modos VGA*/
  {
   _AX = modos[indice] & 0x00FF;
   asm int 0x10;
  }
  else
      SetSVGAVideoMode(modos[indice], Xtotal, Ytotal );

  SetPalette (paleta);
  Descomprime_PCX (fich);

  fclose (fich);
  return (cabeceraPCX);
}

void Descomprime_PCX (FILE * fichero)
{
  int a, x, y;
  dword pos;
  byte dato1, dato2;

  pos = 0;
  fseek (fichero, 128, SEEK_SET);           /* Saltamos la cabecera */

for (a=0;a<Ytotal;a++)                      /* Bucle que controla en alto */
{                                           /* del dibujo                 */
  for (x=0;x<cabeceraPCX.BytesPerLine;)        /* Bucle para el ancho de la  */
  {                                         /* imagen                     */
     fread (&dato1, sizeof (dato1), 1, fichero);     /* Leemos el valor   */
     if (dato1 > 192  )                              /* Si los dos bits altos */
     {                                               /* estn activados ...   */
	fread (&dato2, sizeof (dato2), 1, fichero);  /* Leer segundo valor    */
	for (y=0;y<(dato1 - 192);y++,pos++, x++)     /* Repetir (dato1 sin los bits superiores) veces */
	     SVGAPutPixelAbs ( pos, dato2 );                /* escribir dato2 en pantalla */
     }
     else                                            /* Si dos bits altos desactivados, */
     {                                               /* escribe en pantalla dato1 */
	 SVGAPutPixelAbs ( pos, dato1);
	 pos++; x++;
     }
  }
  pos += ancho-cabeceraPCX.BytesPerLine ;               /* Si la imagen es ms estrecha que el
							ancho de la resolucin, aadir el
							resto que falta a cada linea */
}
}
