/*
   - Include para descomprimir imgenes RAW de 256 colores y resoluciones
   desde 320x200 hasta 1024x768.

*/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "palette.h"
#include "svgalibs\vesalib.h"

#ifndef STANDARDTYPES
    #define STANDARDTYPES
      typedef  unsigned char *  address;
      typedef  unsigned char    byte;
      typedef  unsigned short   word;
      typedef  unsigned long    dword;
 #endif

typedef struct {
   byte Bits_por_pixel;
   word ancho;
   word alto;
} RAW_HDR;

RAW_HDR RAW (char * nombre );
void descomprime (FILE *);

int modos [4] = {         /*    modos[modos]        */
       /*  320x200    640x480     800x600   1024x768   */
	   0xFF13  ,  0x0101  ,   0x0103  ,  0x0105
		    };

char indice ; /* indices para el array de modos */
byte paleta [768];
RAW_HDR cabecera;
int x;
int ancho_pant;

RAW_HDR RAW ( char * nombre)
{
  FILE * fich;

  fich = fopen (nombre, "rb" );
  if (fich == NULL)
  {
    printf ("Error abriendo el fichero ");
    exit (1);
  }
  
  fread (&cabecera, sizeof (cabecera), 1, fich);
  
  clrscr();

       if ( ( cabecera.ancho <= 320 ) && ( cabecera.alto <= 200 ) )
	  {indice = 0;
	  ancho_pant = 320;}
  else if ( ( cabecera.ancho <= 640 ) && ( cabecera.alto <= 480 ) )
	  {indice = 1;
	  ancho_pant = 640;}
  else if ( ( cabecera.ancho <= 800 ) && ( cabecera.alto <= 600 ) )
	  {indice = 2;
	  ancho_pant = 800;}
  else if ( ( cabecera.ancho <=1024 ) && ( cabecera.alto <= 768 ) )
	  {indice = 3;
	  ancho_pant =1024;}
  else indice = -1;   /* Imagen demasiado grande! */

  if ( cabecera.Bits_por_pixel == 8 )
	{
	  fseek (fich, 5, SEEK_SET);          /* Salta cabecera */
	  fread (paleta , 768, 1, fich);
	}
  else
	{
	  printf ("Slo admite 256 colores!\r\n");
	  exit(1);
	}

  if ( (modos[indice] & 0xFF00) == 0xFF00)  /*modos VGA*/
  {
   _AX = modos[indice] & 0x00FF;
   asm int 0x10;
  } else 
	SetSVGAVideoMode(modos[indice], cabecera.ancho, cabecera.alto );

  SetPalette (paleta );
  descomprime (fich);

  fclose (fich);
  return (cabecera);
}


void descomprime (FILE * fichero)
{
  int a, x, y;
  dword pos;
  char valor;
  word ancho=0;

  pos = 0;
  fseek (fichero, 768, SEEK_SET);

  fread (&valor, 1, 1, fichero);
  while (!feof(fichero))
  {
    fread (&valor, 1, 1, fichero);
    if (ancho == cabecera.ancho)
       {
	 pos += (ancho_pant - cabecera.ancho)-1;
	 ancho = 0;
       } else ancho++;
    SVGAPutPixelAbs (pos, valor);
    pos++;
  };
}
